OpenTTD Source: BaseGraphWindow Struct Reference

OpenTTD Source 15.3

Data Structures | Public Member Functions | Protected Member Functions | Protected Attributes | Static Protected Attributes
BaseGraphWindow Struct Referenceabstract
Inheritance diagram for BaseGraphWindow:

## Data Structures
struct | BaseFiller
struct | DataSet
struct | Filler
struct | GraphScale

## Public Member Functions
void | UpdateWidgetSize (WidgetID widget, Dimension &size, const Dimension &padding, Dimension &fill, Dimension &resize) override
| Update size and resize step of a widget in the window.
void | DrawWidget (const Rect &r, WidgetID widget) const override
| Draw the contents of a nested widget.
void | OnClick (Point pt, WidgetID widget, int click_count) override
| A click with the left mouse button has been made on the window.
void | OnMouseOver (Point pt, WidgetID widget) override
| The mouse is currently moving over the window or has just moved outside of the window.
void | OnGameTick () override
| Called once per (game) tick.
void | OnInvalidateData (int data=0, bool gui_scope=true) override
| Some data on this window has become invalid.
virtual void | UpdateStatistics (bool initialize)=0
virtual std::optional< uint8_t > | GetDatasetIndex (int)
Public Member Functions inherited from Window
| Window (WindowDesc &desc)
| Empty constructor, initialization has been moved to InitNested() called from the constructor of the derived class.
void * | operator new[] (size_t size)=delete
| Helper allocation function to disallow something.
template<class NWID >
const NWID * | GetWidget (WidgetID widnum) const
| Get the nested widget with number widnum from the nested widget tree.
template<class NWID >
NWID * | GetWidget (WidgetID widnum)
| Get the nested widget with number widnum from the nested widget tree.
const Scrollbar * | GetScrollbar (WidgetID widnum) const
| Return the Scrollbar to a widget index.
Scrollbar * | GetScrollbar (WidgetID widnum)
| Return the Scrollbar to a widget index.
const QueryString * | GetQueryString (WidgetID widnum) const
| Return the querystring associated to a editbox.
QueryString * | GetQueryString (WidgetID widnum)
| Return the querystring associated to a editbox.
void | UpdateQueryStringSize ()
| Update size of all QueryStrings of this window.
virtual const struct Textbuf * | GetFocusedTextbuf () const
| Get the current input text buffer.
virtual Point | GetCaretPosition () const
| Get the current caret position if an edit box has the focus.
virtual Rect | GetTextBoundingRect (size_t from, size_t to) const
| Get the bounding rectangle for a text range if an edit box has the focus.
virtual ptrdiff_t | GetTextCharacterAtPosition (const Point &pt) const
| Get the character that is rendered at a position by the focused edit box.
void | InitNested (WindowNumber number=0)
| Perform complete initialization of the Window with nested widgets, to allow use.
void | CreateNestedTree ()
| Perform the first part of the initialization of a nested widget tree.
void | FinishInitNested (WindowNumber window_number=0)
| Perform the second part of the initialization of a nested widget tree.
void | SetTimeout ()
| Set the timeout flag of the window and initiate the timer.
void | SetWhiteBorder ()
| Set the timeout flag of the window and initiate the timer.
void | DisableAllWidgetHighlight ()
| Disable the highlighted status of all widgets.
void | SetWidgetHighlight (WidgetID widget_index, TextColour highlighted_colour)
| Sets the highlighted status of a widget.
bool | IsWidgetHighlighted (WidgetID widget_index) const
| Gets the highlighted status of a widget.
void | SetWidgetDisabledState (WidgetID widget_index, bool disab_stat)
| Sets the enabled/disabled status of a widget.
void | DisableWidget (WidgetID widget_index)
| Sets a widget to disabled.
void | EnableWidget (WidgetID widget_index)
| Sets a widget to Enabled.
bool | IsWidgetDisabled (WidgetID widget_index) const
| Gets the enabled/disabled status of a widget.
bool | IsWidgetFocused (WidgetID widget_index) const
| Check if given widget is focused within this window.
bool | IsWidgetGloballyFocused (WidgetID widget_index) const
| Check if given widget has user input focus.
void | SetWidgetLoweredState (WidgetID widget_index, bool lowered_stat)
| Sets the lowered/raised status of a widget.
void | ToggleWidgetLoweredState (WidgetID widget_index)
| Invert the lowered/raised status of a widget.
void | LowerWidget (WidgetID widget_index)
| Marks a widget as lowered.
void | RaiseWidget (WidgetID widget_index)
| Marks a widget as raised.
void | RaiseWidgetWhenLowered (WidgetID widget_index)
| Marks a widget as raised and dirty (redraw), when it is marked as lowered.
bool | IsWidgetLowered (WidgetID widget_index) const
| Gets the lowered state of a widget.
void | UnfocusFocusedWidget ()
| Makes no widget on this window have focus.
bool | SetFocusedWidget (WidgetID widget_index)
| Set focus within this window to the given widget.
EventState | HandleEditBoxKey (WidgetID wid, char32_t key, uint16_t keycode)
| Process keypress for editbox widget.
virtual void | InsertTextString (WidgetID wid, std::string_view str, bool marked, std::optional< size_t > caret, std::optional< size_t > insert_location, std::optional< size_t > replacement_end)
| Insert a text string at the cursor position into the edit box widget.
void | HandleButtonClick (WidgetID widget)
| Do all things to make a button look clicked and mark it to be unclicked in a few ticks.
int | GetRowFromWidget (int clickpos, WidgetID widget, int padding, int line_height=-1) const
| Compute the row of a widget that a user clicked in.
void | RaiseButtons (bool autoraise=false)
| Raise the buttons of the window.
template<typename... Args>
void | SetWidgetsDisabledState (bool disab_stat, Args... widgets)
| Sets the enabled/disabled status of a list of widgets.
template<typename... Args>
void | SetWidgetsLoweredState (bool lowered_stat, Args... widgets)
| Sets the lowered/raised status of a list of widgets.
template<typename... Args>
void | RaiseWidgetsWhenLowered (Args... widgets)
| Raises the widgets and sets widgets dirty that are lowered.
void | SetWidgetDirty (WidgetID widget_index) const
| Invalidate a widget, i.e.
void | DrawWidgets () const
| Paint all widgets of a window.
void | DrawViewport () const
| Draw the viewport of this window.
void | DrawSortButtonState (WidgetID widget, SortButtonState state) const
| Draw a sort button's up or down arrow symbol.
Window * | FindChildWindow (WindowClass wc=WC_INVALID) const
| Find the Window whose parent pointer points to this window.
Window * | FindChildWindowById (WindowClass wc, WindowNumber number) const
| Find the Window whose parent pointer points to this window.
void | CloseChildWindows (WindowClass wc=WC_INVALID) const
| Close all children a window might have in a head-recursive manner.
void | CloseChildWindowById (WindowClass wc, WindowNumber number) const
| Close all children a window might have in a head-recursive manner.
virtual void | Close (int data=0)
| Hide the window and all its child windows, and mark them for a later deletion.
void | SetDirty () const
| Mark entire window as dirty (in need of re-paint)
void | ReInit (int rx=0, int ry=0, bool reposition=false)
| Re-initialize a window, and optionally change its size.
bool | IsShaded () const
| Is window shaded currently?
void | SetShaded (bool make_shaded)
| Set the shaded state of the window to make_shaded.
void | ScheduleResize ()
| Mark this window as resized and in need of OnResize() event.
void | ProcessScheduledResize ()
| Process scheduled OnResize() event.
void | InvalidateData (int data=0, bool gui_scope=true)
| Mark this window's data as invalid (in need of re-computing)
void | ProcessScheduledInvalidations ()
| Process all scheduled invalidations.
void | ProcessHighlightedInvalidations ()
| Process all invalidation of highlighted widgets.
virtual void | OnInit ()
| Notification that the nested widget tree gets initialized.
virtual void | ApplyDefaults ()
| Read default values from WindowDesc configuration an apply them to the window.
virtual Point | OnInitialPosition (int16_t sm_width, int16_t sm_height, int window_number)
| Compute the initial position of the window.
virtual void | OnPaint ()
| The window must be repainted.
virtual std::string | GetWidgetString (WidgetID widget, StringID stringid) const
| Get the raw string for a widget.
virtual void | OnFocus ()
| The window has gained focus.
virtual void | OnFocusLost (bool closing)
| The window has lost focus.
virtual EventState | OnKeyPress (char32_t key, uint16_t keycode)
| A key has been pressed.
virtual EventState | OnHotkey (int hotkey)
| A hotkey has been pressed.
virtual EventState | OnCTRLStateChange ()
| The state of the control key has changed.
virtual bool | OnRightClick (Point pt, WidgetID widget)
| A click with the right mouse button has been made on the window.
virtual void | OnHover (Point pt, WidgetID widget)
| The mouse is hovering over a widget in the window, perform an action for it.
virtual bool | OnTooltip (Point pt, WidgetID widget, TooltipCloseCondition close_cond)
| Event to display a custom tooltip.
virtual void | OnMouseDrag (Point pt, WidgetID widget)
| An 'object' is being dragged at the provided position, highlight the target if possible.
virtual void | OnDragDrop (Point pt, WidgetID widget)
| A dragged 'object' has been released.
virtual void | OnScroll (Point delta)
| Handle the request for (viewport) scrolling.
virtual void | OnScrollbarScroll (WidgetID widget)
| Notify window that a scrollbar position has been updated.
virtual void | OnMouseWheel (int wheel, WidgetID widget)
| The mouse wheel has been turned.
virtual void | OnMouseLoop ()
| Called for every mouse loop run, which is at least once per (game) tick.
virtual void | OnRealtimeTick (uint delta_ms)
| Called periodically.
virtual void | OnTimeout ()
| Called when this window's timeout has been reached.
virtual void | OnResize ()
| Called after the window got resized.
virtual void | OnDropdownSelect (WidgetID widget, int index, int click_result)
| A dropdown option associated to this window has been selected.
virtual void | OnDropdownClose (Point pt, WidgetID widget, int index, int click_result, bool instant_close)
| A dropdown window associated to this window has been closed.
virtual void | OnEditboxChanged (WidgetID widget)
| The text in an editbox has been edited.
virtual void | OnQueryTextFinished (std::optional< std::string > str)
| The query window opened from this window has closed.
virtual void | OnPlaceObject (Point pt, TileIndex tile)
| The user clicked some place on the map when a tile highlight mode has been set.
virtual bool | OnVehicleSelect (const struct Vehicle *v)
| The user clicked on a vehicle while HT_VEHICLE has been set.
virtual bool | OnVehicleSelect (VehicleList::const_iterator begin, VehicleList::const_iterator end)
| The user clicked on a vehicle while HT_VEHICLE has been set.
virtual void | OnPlaceObjectAbort ()
| The user cancelled a tile highlight mode that has been set.
virtual void | OnPlaceDrag (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt)
| The user is dragging over the map when the tile highlight mode has been set.
virtual void | OnPlaceMouseUp (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt, TileIndex start_tile, TileIndex end_tile)
| The user has dragged over the map when the tile highlight mode has been set.
virtual void | OnPlacePresize (Point pt, TileIndex tile)
| The user moves over the map when a tile highlight mode has been set when the special mouse mode has been set to 'PRESIZE' mode.
virtual bool | IsNewGRFInspectable () const
| Is the data related to this window NewGRF inspectable?
virtual void | ShowNewGRFInspectWindow () const
| Show the NewGRF inspection window.
template<>
const NWidgetBase * | GetWidget (WidgetID widnum) const
| Specialized case of Window::GetWidget for the nested widget base class.

## Protected Member Functions
std::span< const OverflowSafeInt64 > | GetDataSetRange (const DataSet &dataset) const
| Get appropriate part of dataset values for the current number of horizontal points.
ValuesInterval | GetValuesInterval (int num_hori_lines) const
| Get the interval that contains the graph's data.
uint | GetYLabelWidth (ValuesInterval current_interval, int num_hori_lines) const
| Get width for Y labels.
void | DrawGraph (Rect r) const
| Actually draw the graph.
| BaseGraphWindow (WindowDesc &desc, StringID format_str_y_axis)
void | UpdateMatrixSize (WidgetID widget, Dimension &size, Dimension &resize, auto labels)
Protected Member Functions inherited from Window
void | InitializeData (WindowNumber window_number)
| Initializes the data (except the position and initial size) of a new Window.
void | InitializePositionSize (int x, int y, int min_width, int min_height)
| Set the position and smallest size of the window.
virtual void | FindWindowPlacementAndResize (int def_width, int def_height, bool allow_resize)
| Resize window towards the default size.
virtual | ~Window ()
| Remove window and all its child windows from the window stack.

## Protected Attributes
uint64_t | excluded_data = 0
| bitmask of datasets hidden by the player.
uint64_t | excluded_range = 0
| bitmask of ranges hidden by the player.
uint64_t | masked_range = 0
| bitmask of ranges that are not available for the current data.
uint8_t | num_on_x_axis = 0
uint8_t | num_vert_lines = GRAPH_NUM_MONTHS
TimerGameEconomy::Month | month {}
TimerGameEconomy::Year | year {}
uint8_t | month_increment = 3
| month increment between vertical lines. must be divisor of 12.
bool | draw_dates = true
| Should we draw months and years on the time axis?
bool | x_values_reversed = true
int16_t | x_values_increment = ECONOMY_QUARTER_MINUTES
StringID | format_str_y_axis {}
std::vector< DataSet > | data {}
std::span< const StringID > | ranges {}
std::span< const GraphScale > | scales {}
uint8_t | selected_scale = 0
uint8_t | highlight_data = UINT8_MAX
| Data set that should be highlighted, or UINT8_MAX for none.
uint8_t | highlight_range = UINT8_MAX
| Data range that should be highlighted, or UINT8_MAX for none.
bool | highlight_state = false
| Current state of highlight, toggled every TIMER_BLINK_INTERVAL period.
const IntervalTimer< TimerWindow > | blink_interval
Protected Attributes inherited from Window
std::vector< int > | scheduled_invalidation_data {}
| Data of scheduled OnInvalidateData() calls.
bool | scheduled_resize = false
| Set if window has been resized.

## Static Protected Attributes
static const int | GRAPH_MAX_DATASETS = 64
static constexpr PixelColour | GRAPH_BASE_COLOUR = GREY_SCALE(2)
static constexpr PixelColour | GRAPH_GRID_COLOUR = GREY_SCALE(3)
static constexpr PixelColour | GRAPH_AXIS_LINE_COLOUR = GREY_SCALE(1)
static constexpr PixelColour | GRAPH_ZERO_LINE_COLOUR = GREY_SCALE(8)
static constexpr PixelColour | GRAPH_YEAR_LINE_COLOUR = GREY_SCALE(5)
static const int | GRAPH_NUM_MONTHS = 24
| Number of months displayed in the graph.
static const int | GRAPH_PAYMENT_RATE_STEPS = 20
| Number of steps on Payment rate graph.
static const int | PAYMENT_GRAPH_X_STEP_DAYS = 10
| X-axis step label for cargo payment rates "Days in transit".
static const int | PAYMENT_GRAPH_X_STEP_SECONDS = 20
| X-axis step label for cargo payment rates "Seconds in transit".
static const int | ECONOMY_YEAR_MINUTES = 12
| Minutes per economic year.
static const int | ECONOMY_QUARTER_MINUTES = 3
| Minutes per economic quarter.
static const int | ECONOMY_MONTH_MINUTES = 1
| Minutes per economic month.
static const TextColour | GRAPH_AXIS_LABEL_COLOUR = TC_BLACK
| colour of the graph axis label.
static const int | MIN_GRAPH_NUM_LINES_Y = 9
| Minimal number of horizontal lines to draw.
static const int | MIN_GRID_PIXEL_SIZE = 20
| Minimum distance between graph lines.
static constexpr GraphScale | MONTHLY_SCALE_WALLCLOCK []
static constexpr GraphScale | MONTHLY_SCALE_CALENDAR []

## Additional Inherited Members
Public Types inherited from Window
using | IteratorToFront = WindowIterator< false >
| Iterate in Z order towards front.
using | IteratorToBack = WindowIterator< true >
| Iterate in Z order towards back.
using | Iterate = AllWindows< false >
| Iterate all windows in whatever order is easiest.
using | IterateFromBack = AllWindows< false >
| Iterate all windows in Z order from back to front.
using | IterateFromFront = AllWindows< true >
| Iterate all windows in Z order from front to back.
Static Public Member Functions inherited from Window
static int | SortButtonWidth ()
| Get width of up/down arrow of sort button state.
static void | DeleteClosedWindows ()
| Delete all closed windows.
Data Fields inherited from Window
WindowDesc & | window_desc
| Window description.
WindowFlags | flags {}
| Window flags.
WindowClass | window_class {}
| Window class.
WindowNumber | window_number = 0
| Window number within the window class.
int | scale = 0
| Scale of this window – used to determine how to resize.
uint8_t | timeout_timer = 0
| Timer value of the WindowFlag::Timeout for flags.
uint8_t | white_border_timer = 0
| Timer value of the WindowFlag::WhiteBorder for flags.
int | left = 0
| x position of left edge of the window
int | top = 0
| y position of top edge of the window
int | width = 0
| width of the window (number of pixels to the right in x direction)
int | height = 0
| Height of the window (number of pixels down in y direction)
ResizeInfo | resize {}
| Resize information.
Owner | owner = INVALID_OWNER
| The owner of the content shown in this window. Company colour is acquired from this variable.
std::unique_ptr< ViewportData > | viewport
| Pointer to viewport data, if present.
const NWidgetCore * | nested_focus = nullptr
| Currently focused nested widget, or `nullptr` if no nested widget has focus.
std::map< WidgetID, QueryString * > | querystrings {}
| QueryString associated to WWT_EDITBOX widgets.
std::unique_ptr< NWidgetBase > | nested_root {}
| Root of the nested tree.
WidgetLookup | widget_lookup {}
| Indexed access to the nested widget tree. Do not access directly, use Window::GetWidget() instead.
NWidgetStacked * | shade_select = nullptr
| Selection widget (NWID_SELECTION) to use for shading the window. If `nullptr`, window cannot shade.
Dimension | unshaded_size {}
| Last known unshaded size (only valid while shaded).
WidgetID | mouse_capture_widget = INVALID_WIDGET
| ID of current mouse capture widget (e.g. dragged scrollbar). `INVALID_WIDGET` if no widget has mouse capture.
Window * | parent = nullptr
| Parent window.
WindowList::iterator | z_position {}

## Detailed Description

Definition at line 170 of file graph_gui.cpp.

## Constructor & Destructor Documentation

## ◆ BaseGraphWindow()

BaseGraphWindow::BaseGraphWindow | ( | WindowDesc & | desc,
|  | StringID | format_str_y_axis
| ) |  |
| inlineprotected

Definition at line 629 of file graph_gui.cpp.

## Member Function Documentation

## ◆ DrawGraph()

void BaseGraphWindow::DrawGraph | ( | Rect | r | ) | const
| inlineprotected

Actually draw the graph.

Parameters

  r | the rectangle of the data field of the graph

< Reused whenever x and y coordinates are needed.

< Interval that contains all of the graph data.

< Distance from the top of the graph to the x axis.

Definition at line 369 of file graph_gui.cpp.

References _current_text_dir, _settings_client, abs(), WidgetDimensions::bevel, DrawString(), DrawStringMultiLineWithClipping(), FS_SMALL, GetCharacterHeight(), GetDataSetRange(), GetString(), GetValuesInterval(), GetYLabelWidth(), GfxFillRect(), GRAPH_AXIS_LABEL_COLOUR, GUISettings::graph_line_thickness, ClientSettings::gui, HasBit(), Window::height, ValuesInterval::highest, ValuesInterval::lowest, MIN_GRID_PIXEL_SIZE, month_increment, NUM_CARGO, PC_WHITE, Window::resize, SA_FORCE, SA_HOR_CENTER, SA_LEFT, SA_RIGHT, WidgetDimensions::scaled, ScaleGUITrad(), TD_RTL, and TimerGameEconomy::UsingWallclockUnits().

Referenced by DrawWidget().

## ◆ DrawWidget()

void BaseGraphWindow::DrawWidget | ( | const Rect & | r,
|  | WidgetID | widget
| ) |  | const
| inlineoverridevirtual

Draw the contents of a nested widget.

Parameters

  r | Rectangle occupied by the widget.
  widget | Number of the widget to draw.

Note
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 702 of file graph_gui.cpp.

References WidgetDimensions::bevel, DrawFrameRect(), DrawGraph(), DrawString(), FILLRECT_CHECKER, WidgetDimensions::framerect, FS_SMALL, GetCharacterHeight(), GetColourGradient(), GfxFillRect(), HasBit(), Lowered, SA_CENTER, Window::scale, WidgetDimensions::scaled, Rect::Shrink(), Rect::Translate(), RectPadding::Vertical(), WID_GRAPH_GRAPH, WID_GRAPH_RANGE_MATRIX, WID_GRAPH_SCALE_MATRIX, and Rect::WithHeight().

Referenced by BaseCargoGraphWindow::DrawWidget().

## ◆ GetDatasetIndex()

virtual std::optional< uint8_t > BaseGraphWindow::GetDatasetIndex | ( | int |  | ) |
| inlinevirtual

Definition at line 828 of file graph_gui.cpp.

## ◆ GetDataSetRange()

std::span< const OverflowSafeInt64 > BaseGraphWindow::GetDataSetRange | ( | const DataSet & | dataset | ) | const
| inlineprotected

Get appropriate part of dataset values for the current number of horizontal points.

Parameters

  dataset | Dataset to get values of

Returns
  span covering dataset's current valid range.

Definition at line 266 of file graph_gui.cpp.

Referenced by DrawGraph(), and GetValuesInterval().

## ◆ GetValuesInterval()

ValuesInterval BaseGraphWindow::GetValuesInterval | ( | int | num_hori_lines | ) | const
| inlineprotected

Get the interval that contains the graph's data.

Excluded data is ignored to show smaller values in better detail when disabling higher ones.

Parameters

  num_hori_lines | Number of horizontal lines to be drawn.

Returns
  Highest and lowest values of the graph (ignoring disabled data).

Definition at line 277 of file graph_gui.cpp.

References abs(), GetDataSetRange(), HasBit(), ValuesInterval::highest, INT64_MAX_IN_DOUBLE, and ValuesInterval::lowest.

Referenced by DrawGraph().

## ◆ GetYLabelWidth()

uint BaseGraphWindow::GetYLabelWidth | ( | ValuesInterval | current_interval,
|  | int | num_hori_lines
| ) |  | const
| inlineprotected

Get width for Y labels.

Parameters

  current_interval | Interval that contains all of the graph data.
  num_hori_lines | Number of horizontal lines to be drawn.

Definition at line 347 of file graph_gui.cpp.

References GetString(), GetStringBoundingBox(), ValuesInterval::highest, and ValuesInterval::lowest.

Referenced by DrawGraph().

## ◆ OnClick()

void BaseGraphWindow::OnClick | ( | Point | pt,
|  | WidgetID | widget,
|  | int | click_count
| ) |  |
| inlineoverridevirtual

A click with the left mouse button has been made on the window.

Parameters

  pt | the point inside the window that has been clicked.
  widget | the clicked widget.
  click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Reimplemented in PerformanceHistoryGraphWindow.

Definition at line 751 of file graph_gui.cpp.

References FS_SMALL, GetCharacterHeight(), Window::GetRowFromWidget(), HasBit(), Window::InvalidateData(), Window::scale, WidgetDimensions::scaled, Window::SetDirty(), SndClickBeep(), ToggleBit(), WID_GRAPH_KEY_BUTTON, WID_GRAPH_RANGE_MATRIX, and WID_GRAPH_SCALE_MATRIX.

Referenced by PerformanceHistoryGraphWindow::OnClick(), and BaseCargoGraphWindow::OnClick().

## ◆ OnGameTick()

void BaseGraphWindow::OnGameTick | ( |  | ) |
| inlineoverridevirtual

Called once per (game) tick.

Reimplemented from Window.

Definition at line 810 of file graph_gui.cpp.

## ◆ OnInvalidateData()

void BaseGraphWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true`
| ) |  |
| inlineoverridevirtual

Some data on this window has become invalid.

Parameters

  data | Information about the changed data.
  gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Reimplemented in PaymentRatesGraphWindow.

Definition at line 820 of file graph_gui.cpp.

## ◆ OnMouseOver()

void BaseGraphWindow::OnMouseOver | ( | Point | pt,
|  | WidgetID | widget
| ) |  |
| inlineoverridevirtual

The mouse is currently moving over the window or has just moved outside of the window.

In the latter case pt is (-1, -1).

Parameters

  pt | the point inside the window that the mouse hovers over.
  widget | the widget the mouse hovers over.

Reimplemented from Window.

Definition at line 785 of file graph_gui.cpp.

References FS_SMALL, GetCharacterHeight(), Window::GetRowFromWidget(), HasBit(), WidgetDimensions::scaled, Window::SetDirty(), WID_GRAPH_MATRIX, WID_GRAPH_RANGE_MATRIX, and Coord2D< T >::y.

## ◆ UpdateMatrixSize()

void BaseGraphWindow::UpdateMatrixSize | ( | WidgetID | widget,
|  | Dimension & | size,
|  | Dimension & | resize,
|  | auto | labels
| ) |  |
| inlineprotected

Definition at line 645 of file graph_gui.cpp.

## ◆ UpdateStatistics()

virtual void BaseGraphWindow::UpdateStatistics | ( | bool | initialize | ) |
| pure virtual

Implemented in BaseCompanyGraphWindow.

## ◆ UpdateWidgetSize()

void BaseGraphWindow::UpdateWidgetSize | ( | WidgetID | widget,
|  | Dimension & | size,
|  | const Dimension & | padding,
|  | Dimension & | fill,
|  | Dimension & | resize
| ) |  |
| inlineoverridevirtual

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters

  | widget | Widget number.
  [in,out] | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  [in,out] | fill | Fill step of the widget.
  [in,out] | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 664 of file graph_gui.cpp.

References FS_SMALL, GetCharacterHeight(), GetParamMaxValue(), GetString(), GetStringBoundingBox(), MIN_GRAPH_NUM_LINES_Y, Window::resize, ScaleGUITrad(), WID_GRAPH_GRAPH, WID_GRAPH_RANGE_MATRIX, and WID_GRAPH_SCALE_MATRIX.

Referenced by BaseCargoGraphWindow::UpdateWidgetSize().

## Field Documentation

## ◆ blink_interval

const IntervalTimer<TimerWindow> BaseGraphWindow::blink_interval
| protected

Initial value:
= {TIMER_BLINK_INTERVAL, [this](auto) {
if (this->highlight_data == UINT8_MAX && this->highlight_range == UINT8_MAX) return;
this->highlight_state = !this->highlight_state;
this->SetDirty();
}}
Window::SetDirty
void SetDirty() const
Mark entire window as dirty (in need of re-paint)
Definition window.cpp:968
BaseGraphWindow::highlight_range
uint8_t highlight_range
Data range that should be highlighted, or UINT8_MAX for none.
Definition graph_gui.cpp:244
BaseGraphWindow::highlight_state
bool highlight_state
Current state of highlight, toggled every TIMER_BLINK_INTERVAL period.
Definition graph_gui.cpp:245
BaseGraphWindow::highlight_data
uint8_t highlight_data
Data set that should be highlighted, or UINT8_MAX for none.
Definition graph_gui.cpp:243
TIMER_BLINK_INTERVAL
static constexpr std::chrono::milliseconds TIMER_BLINK_INTERVAL
Interval used by blinking interface elements.
Definition timer_window.h:36

Definition at line 636 of file graph_gui.cpp.

## ◆ data

std::vector<DataSet> BaseGraphWindow::data {}
| protected

Definition at line 237 of file graph_gui.cpp.

## ◆ draw_dates

bool BaseGraphWindow::draw_dates = true
| protected

Should we draw months and years on the time axis?

Definition at line 221 of file graph_gui.cpp.

## ◆ ECONOMY_MONTH_MINUTES

const int BaseGraphWindow::ECONOMY_MONTH_MINUTES = 1
| staticprotected

Minutes per economic month.

Definition at line 184 of file graph_gui.cpp.

## ◆ ECONOMY_QUARTER_MINUTES

const int BaseGraphWindow::ECONOMY_QUARTER_MINUTES = 3
| staticprotected

Minutes per economic quarter.

Definition at line 183 of file graph_gui.cpp.

## ◆ ECONOMY_YEAR_MINUTES

const int BaseGraphWindow::ECONOMY_YEAR_MINUTES = 12
| staticprotected

Minutes per economic year.

Definition at line 182 of file graph_gui.cpp.

## ◆ excluded_data

uint64_t BaseGraphWindow::excluded_data = 0
| protected

bitmask of datasets hidden by the player.

Definition at line 210 of file graph_gui.cpp.

## ◆ excluded_range

uint64_t BaseGraphWindow::excluded_range = 0
| protected

bitmask of ranges hidden by the player.

Definition at line 211 of file graph_gui.cpp.

## ◆ format_str_y_axis

StringID BaseGraphWindow::format_str_y_axis {}
| protected

Definition at line 228 of file graph_gui.cpp.

## ◆ GRAPH_AXIS_LABEL_COLOUR

const TextColour BaseGraphWindow::GRAPH_AXIS_LABEL_COLOUR = TC_BLACK
| staticprotected

colour of the graph axis label.

Definition at line 186 of file graph_gui.cpp.

Referenced by DrawGraph().

## ◆ GRAPH_AXIS_LINE_COLOUR

constexpr PixelColour BaseGraphWindow::GRAPH_AXIS_LINE_COLOUR = GREY_SCALE(1)
| staticconstexprprotected

Definition at line 175 of file graph_gui.cpp.

## ◆ GRAPH_BASE_COLOUR

constexpr PixelColour BaseGraphWindow::GRAPH_BASE_COLOUR = GREY_SCALE(2)
| staticconstexprprotected

Definition at line 173 of file graph_gui.cpp.

## ◆ GRAPH_GRID_COLOUR

constexpr PixelColour BaseGraphWindow::GRAPH_GRID_COLOUR = GREY_SCALE(3)
| staticconstexprprotected

Definition at line 174 of file graph_gui.cpp.

## ◆ GRAPH_MAX_DATASETS

const int BaseGraphWindow::GRAPH_MAX_DATASETS = 64
| staticprotected

Definition at line 172 of file graph_gui.cpp.

## ◆ GRAPH_NUM_MONTHS

const int BaseGraphWindow::GRAPH_NUM_MONTHS = 24
| staticprotected

Number of months displayed in the graph.

Definition at line 178 of file graph_gui.cpp.

## ◆ GRAPH_PAYMENT_RATE_STEPS

const int BaseGraphWindow::GRAPH_PAYMENT_RATE_STEPS = 20
| staticprotected

Number of steps on Payment rate graph.

Definition at line 179 of file graph_gui.cpp.

## ◆ GRAPH_YEAR_LINE_COLOUR

constexpr PixelColour BaseGraphWindow::GRAPH_YEAR_LINE_COLOUR = GREY_SCALE(5)
| staticconstexprprotected

Definition at line 177 of file graph_gui.cpp.

## ◆ GRAPH_ZERO_LINE_COLOUR

constexpr PixelColour BaseGraphWindow::GRAPH_ZERO_LINE_COLOUR = GREY_SCALE(8)
| staticconstexprprotected

Definition at line 176 of file graph_gui.cpp.

## ◆ highlight_data

uint8_t BaseGraphWindow::highlight_data = UINT8_MAX
| protected

Data set that should be highlighted, or UINT8_MAX for none.

Definition at line 243 of file graph_gui.cpp.

## ◆ highlight_range

uint8_t BaseGraphWindow::highlight_range = UINT8_MAX
| protected

Data range that should be highlighted, or UINT8_MAX for none.

Definition at line 244 of file graph_gui.cpp.

## ◆ highlight_state

bool BaseGraphWindow::highlight_state = false
| protected

Current state of highlight, toggled every TIMER_BLINK_INTERVAL period.

Definition at line 245 of file graph_gui.cpp.

## ◆ masked_range

uint64_t BaseGraphWindow::masked_range = 0
| protected

bitmask of ranges that are not available for the current data.

Definition at line 212 of file graph_gui.cpp.

## ◆ MIN_GRAPH_NUM_LINES_Y

const int BaseGraphWindow::MIN_GRAPH_NUM_LINES_Y = 9
| staticprotected

Minimal number of horizontal lines to draw.

Definition at line 188 of file graph_gui.cpp.

Referenced by UpdateWidgetSize().

## ◆ MIN_GRID_PIXEL_SIZE

const int BaseGraphWindow::MIN_GRID_PIXEL_SIZE = 20
| staticprotected

Minimum distance between graph lines.

Definition at line 189 of file graph_gui.cpp.

Referenced by DrawGraph().

## ◆ month

TimerGameEconomy::Month BaseGraphWindow::month {}
| protected

Definition at line 217 of file graph_gui.cpp.

## ◆ month_increment

uint8_t BaseGraphWindow::month_increment = 3
| protected

month increment between vertical lines. must be divisor of 12.

Definition at line 219 of file graph_gui.cpp.

Referenced by DrawGraph().

## ◆ MONTHLY_SCALE_CALENDAR

constexpr GraphScale BaseGraphWindow::MONTHLY_SCALE_CALENDAR[]
| inlinestaticconstexprprotected

Initial value:
= {
{STR_GRAPH_LAST_24_MONTHS, HISTORY_MONTH.total_division, ECONOMY_MONTH_MINUTES, &HISTORY_MONTH},
{STR_GRAPH_LAST_24_QUARTERS, HISTORY_QUARTER.total_division, ECONOMY_QUARTER_MINUTES, &HISTORY_QUARTER},
{STR_GRAPH_LAST_24_YEARS, HISTORY_YEAR.total_division, ECONOMY_YEAR_MINUTES, &HISTORY_YEAR},
}
BaseGraphWindow::ECONOMY_QUARTER_MINUTES
static const int ECONOMY_QUARTER_MINUTES
Minutes per economic quarter.
Definition graph_gui.cpp:183
BaseGraphWindow::ECONOMY_MONTH_MINUTES
static const int ECONOMY_MONTH_MINUTES
Minutes per economic month.
Definition graph_gui.cpp:184
BaseGraphWindow::ECONOMY_YEAR_MINUTES
static const int ECONOMY_YEAR_MINUTES
Minutes per economic year.
Definition graph_gui.cpp:182

Definition at line 204 of file graph_gui.cpp.

## ◆ MONTHLY_SCALE_WALLCLOCK

constexpr GraphScale BaseGraphWindow::MONTHLY_SCALE_WALLCLOCK[]
| inlinestaticconstexprprotected

Initial value:
= {
{STR_GRAPH_LAST_24_MINUTES_TIME_LABEL, HISTORY_MONTH.total_division, ECONOMY_MONTH_MINUTES, &HISTORY_MONTH},
{STR_GRAPH_LAST_72_MINUTES_TIME_LABEL, HISTORY_QUARTER.total_division, ECONOMY_QUARTER_MINUTES, &HISTORY_QUARTER},
{STR_GRAPH_LAST_288_MINUTES_TIME_LABEL, HISTORY_YEAR.total_division, ECONOMY_YEAR_MINUTES, &HISTORY_YEAR},
}

Definition at line 198 of file graph_gui.cpp.

## ◆ num_on_x_axis

uint8_t BaseGraphWindow::num_on_x_axis = 0
| protected

Definition at line 213 of file graph_gui.cpp.

## ◆ num_vert_lines

uint8_t BaseGraphWindow::num_vert_lines = GRAPH_NUM_MONTHS
| protected

Definition at line 214 of file graph_gui.cpp.

## ◆ PAYMENT_GRAPH_X_STEP_DAYS

const int BaseGraphWindow::PAYMENT_GRAPH_X_STEP_DAYS = 10
| staticprotected

X-axis step label for cargo payment rates "Days in transit".

Definition at line 180 of file graph_gui.cpp.

## ◆ PAYMENT_GRAPH_X_STEP_SECONDS

const int BaseGraphWindow::PAYMENT_GRAPH_X_STEP_SECONDS = 20
| staticprotected

X-axis step label for cargo payment rates "Seconds in transit".

Definition at line 181 of file graph_gui.cpp.

## ◆ ranges

std::span<const StringID> BaseGraphWindow::ranges {}
| protected

Definition at line 239 of file graph_gui.cpp.

## ◆ scales

std::span<const GraphScale> BaseGraphWindow::scales {}
| protected

Definition at line 240 of file graph_gui.cpp.

## ◆ selected_scale

uint8_t BaseGraphWindow::selected_scale = 0
| protected

Definition at line 241 of file graph_gui.cpp.

## ◆ x_values_increment

int16_t BaseGraphWindow::x_values_increment = ECONOMY_QUARTER_MINUTES
| protected

Definition at line 226 of file graph_gui.cpp.

## ◆ x_values_reversed

bool BaseGraphWindow::x_values_reversed = true
| protected

Definition at line 225 of file graph_gui.cpp.

## ◆ year

TimerGameEconomy::Year BaseGraphWindow::year {}
| protected

Definition at line 218 of file graph_gui.cpp.

The documentation for this struct was generated from the following file:

- src/graph_gui.cpp